/*
 * registers.h
 *
 *  Created on: Jan 24, 2013
 *      Author: l_maliakal_d
 */

#ifndef REGISTERS_H_
#define REGISTERS_H_

#include "sls_detector_defs.h"

#define CSP0 				  	0xC4100000		//XPAR_PLB_LL_FIFO_AURORA_DUAL_CTRL_FEB_LEFT_BASEADDR
#define MEM_SIZE 			  	0xFFFFFFF



#define FIFO_CNTRL_REG			0x0				//PLB_LL_FIFO_REG_CTRL
#define FIFO_STATUS_REG			0x1				//PLB_LL_FIFO_REG_STATUS
#define FIFO_FIFO_REG			0x2				//PLB_LL_FIFO_REG_FIFO


#define FIFO_THRESHOLD_WORDS  	100				//PLB_LL_FIFO_ALMOST_FULL_THRESHOLD_WORDS



/*Fifo Control Register*/
#define FIFOCNTRL_RESET_MASK  		0x0CE00000		//PLB_LL_FIFO_CTRL_RESET_STD


/*Fifo Status Register*/
#define FIFOSTATUS_SOF_BIT     		0x10000000		//PLB_LL_FIFO_STATUS_LL_SOF
#define FIFOSTATUS_EOF_BIT	        0x20000000		//PLB_LL_FIFO_STATUS_LL_EOF
#define FIFOSTATUS_REM_OFFSET		30				//PLB_LL_FIFO_STATUS_LL_REM_SHIFT
#define FIFOSTATUS_REM_MASK         0xC0000000		//PLB_LL_FIFO_STATUS_LL_REM

#define FIFOSTATUS_EMPTY_BIT     	0x08000000		//PLB_LL_FIFO_STATUS_EMPTY
#define FIFOSTATUS_ALMOST_FULL_BIT  0x01000000		//PLB_LL_FIFO_STATUS_ALMOSTFULL


/*Fifo Fifo Register*/
#define FIFOCNTRL_SOF_BIT    	 	0x10000000		//PLB_LL_FIFO_CTRL_LL_SOF
#define FIFOCNTRL_EOF_BIT   		0x20000000		//PLB_LL_FIFO_CTRL_LL_EOF
#define FIFOCNTRL_REM_OFFSET    	30				//PLB_LL_FIFO_CTRL_LL_REM_SHIFT
#define FIFOCNTRL_REM_MASK	        0xC0000000		//PLB_LL_FIFO_CTRL_LL_REM
#define FIFOCNTRL_MASK		        0xF0000000		//PLB_LL_FIFO_CTRL_LL_MASK




#define SET_FRAMES_LSB_REG    0x1
#define SET_FRAMES_MSB_REG    0x1
#define GET_FRAMES_LSB_REG    0x1
#define GET_FRAMES_MSB_REG    0x1

#define SET_EXPTIME_LSB_REG   0x1
#define SET_EXPTIME_MSB_REG   0x1
#define GET_EXPTIME_LSB_REG   0x1
#define GET_EXPTIME_MSB_REG   0x1

#define SET_GATES_LSB_REG     0x1
#define SET_GATES_MSB_REG     0x1
#define GET_GATES_LSB_REG     0x1
#define GET_GATES_MSB_REG     0x1

#define SET_PERIOD_LSB_REG    0x1
#define SET_PERIOD_MSB_REG    0x1
#define GET_PERIOD_LSB_REG    0x1
#define GET_PERIOD_MSB_REG    0x1

#define SET_DELAY_LSB_REG     0x1
#define SET_DELAY_MSB_REG     0x1
#define GET_DELAY_LSB_REG     0x1
#define GET_DELAY_MSB_REG     0x1

#define SET_TRAINS_LSB_REG    0x1
#define SET_TRAINS_MSB_REG    0x1
#define GET_TRAINS_LSB_REG    0x1
#define GET_TRAINS_MSB_REG    0x1





#endif /* REGISTERS_H_ */
